"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cdc = void 0;

var _utils = require("../utils");

var _filters = require("../filters");

const cdc = rule => s => s // eslint-disable-line import/prefer-default-export
.filter(_filters.outLatched).filter(onEventType(rule)).tap(_utils.printStartPipeline).filter(onContent(rule)).map(toQueryRequest(rule)).through((0, _utils.query)(rule)).map(toEvent(rule)).parallel(rule.parallel || Number(process.env.PARALLEL) || 4).through(rule.publish(rule)).tap(_utils.printEndPipeline);

exports.cdc = cdc;

const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));

const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));

const toQueryRequest = rule => uow => ({ ...uow,
  queryRequest: !rule.queryRelated ? undefined : {
    KeyConditionExpression: '#pk = :pk',
    ExpressionAttributeNames: {
      '#pk': rule.pkFn || 'pk'
    },
    ExpressionAttributeValues: {
      ':pk': uow.event.partitionKey
    },
    ConsistentRead: true
  }
});

const toEvent = rule => (0, _utils.faultyAsync)(uow => !rule.toEvent ? Promise.resolve(uow) : Promise.resolve(rule.toEvent(uow, rule)).then(event => ({ ...uow,
  event: { ...uow.event,
    ...event
  }
})));