"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.materialize = void 0;

var _bluebird = _interopRequireDefault(require("bluebird"));

var _utils = require("../utils");

var _filters = require("../filters");

var _dynamodb = require("../utils/dynamodb");

const materialize = rule => s => s // eslint-disable-line import/prefer-default-export
.filter(_filters.outSkip).filter(_filters.outSourceIsSelf).filter(onEventType(rule)).tap(_utils.printStartPipeline).filter(onContent(rule)).map(toUpdateRequest(rule)).parallel(rule.parallel || Number(process.env.PARALLEL) || 4).through((0, _dynamodb.update)(rule)).tap(_utils.printEndPipeline);

exports.materialize = materialize;

const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));

const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));

const toUpdateRequest = rule => (0, _utils.faultyAsync)(uow => _bluebird.default.resolve(rule.toUpdateRequest(uow, rule)).then(updateRequest => ({ ...uow,
  updateRequest
})));