"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.faultyAsync = exports.faulty = exports.rejectWithFault = exports.throwFault = void 0;

var _highland = _interopRequireDefault(require("highland"));

var _bluebird = _interopRequireDefault(require("bluebird"));

const throwFault = (uow, ignore = false) => err => {
  /* istanbul ignore else */
  if (!ignore) {
    // adorn the troubled uow
    // for processing in the errors handler
    err.uow = uow;
  }

  throw err;
};

exports.throwFault = throwFault;

const rejectWithFault = (uow, ignore = false) => err => {
  /* istanbul ignore else */
  if (!ignore) {
    // adorn the troubled uow
    // for processing in the errors handler
    err.uow = uow;
  }

  return _bluebird.default.reject(err);
};

exports.rejectWithFault = rejectWithFault;

const faulty = funct => uow => {
  // eslint-disable-line consistent-return
  try {
    return funct(uow);
  } catch (e) {
    throwFault(uow)(e);
  }
};

exports.faulty = faulty;

const faultyAsync = funct => uow => (0, _highland.default)(funct(uow).catch(rejectWithFault));

exports.faultyAsync = faultyAsync;