"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.putObjectToS3 = void 0;

var _highland = _interopRequireDefault(require("highland"));

var _s = _interopRequireDefault(require("../connectors/s3"));

var _faults = require("./faults");

var _print = require("./print");

const putObjectToS3 = ({
  // eslint-disable-line import/prefer-default-export
  debug = (0, _print.debug)('s3'),
  bucketName = process.env.BUCKET_NAME,
  putRequestField = 'putRequest',
  parallel = Number(process.env.S3_PARALLEL) || Number(process.env.PARALLEL) || 8
} = {}) => {
  const connector = new _s.default({
    debug,
    bucketName
  });

  const putObject = uow => {
    const p = connector.putObject(uow[putRequestField]).then(putResponse => ({ ...uow,
      putResponse
    })).catch((0, _faults.rejectWithFault)(uow));
    return (0, _highland.default)(p); // wrap promise in a stream
  };

  return s => s.map(putObject).parallel(parallel);
}; // TODO getObjectFromS3


exports.putObjectToS3 = putObjectToS3;